代码改变世界

[LeetCode] 711. Number of Distinct Islands II_hard tag: DFS

2018-07-12 05:23  Johnson_强生仔仔  阅读(970)  评论(0编辑  收藏  举报

Given a non-empty 2D array grid of 0's and 1's, an island is a group of 1's (representing land) connected 4-directionally (horizontal or vertical.) You may assume all four edges of the grid are surrounded by water.

Count the number of distinct islands. An island is considered to be the same as another if they have the same shape, or have the same shape after rotation (90, 180, or 270 degrees only) or reflection (left/right direction or up/down direction).

Example 1:

11000
10000
00001
00011

Given the above grid map, return 1

Notice that:

11
1

and

 1
11

are considered same island shapes. Because if we make a 180 degrees clockwise rotation on the first island, then two islands will have the same shapes.

 

Example 2:

11100
10001
01001
01110

Given the above grid map, return 2.

Here are the two distinct islands:

111
1

and

1
1


Notice that:

111
1

and

1
111

are considered same island shapes. Because if we flip the first array in the up/down direction, then they have the same shapes.

 

Note: The length of each dimension in the given grid does not exceed 50.

Update 08/17/2018: 注意不能利用 [LeetCode] 694. Number of Distinct Islands里面的dfs function然后直接sort, 否则的话会有负数, 比如

0 1

1 1, 因此我们直接tuple(shape), 然后通过得到xMin, yMin, 然后去tuple.(这样可以避免负数的情况)

 

这个题目实际上就是[LeetCode] 694. Number of Distinct Islands 的变形, 我们实际上还是用那个题目的updated的做法, 用DFS去记录它的相对local 位置, 然后针对翻转和对称能够改变的加上original 位置, 总共有8 种情况, 如果original的每个坐标为(x,y), 那么其他的情况分别为(-x, y), (x,-y), (-x, -y), (y,x), (-y, x), (y, -x), (-y, -x), 只不过因为我们要的是相对位置, 那么每次在改变符号的时候要加上 Xmax or Ymax(注意的是变为local的坐标之后的max), 然后每次判断产生的local 位置在不在我们的shapes这个set里面, 如果不在的话, ans += 1, 并且将8种情况都加入到shapes 的set里面, 最后返回ans即可, 其实相对于694的题目, 只是加入了一个addIsland函数来判断是否可以翻转或者对称来跟已经有的local位置去进行比较.

 

1. Constraints

1) grid 可以empty, edge

2) max size will be [50*50]

3) each element will be 0 or 1

 

2. 思路

DFS, 因为中间有排序的过程, 所以我认为   T; O(m*n lg(m*n))      S; O(m*n)

 

3. Code

class Solution(object):
    def numDistinctIslands2(self, grid):
        if not grid or len(grid[0]) == 0 : return 0
        lrc, visited, ans, shapes = [len(grid), len(grid[0])], set(), [0], set()
        def dfs(i,j):
            if 0<= i < lrc[0] and 0 <= j < lrc[1] and grid[i][j] and (i,j) not in visited:
                visited.add((i,j))
                shape.append((i, j))
                dfs(i-1, j)
                dfs(i+1, j)
                dfs(i, j-1)
                dfs(i, j+1)
        def addShape(shape, shapes):
            xs, ys = zip(*shape)   # get xMin, yMin from original shape
            xMin, yMin = min(xs), min(ys)  # note: 必须通过这种方式来去得到local全部是正数的tuple
            island0 = tuple(sorted((x-xMin, y - yMin) for x,y in shape))
            if island0 in shapes: return
            ans[0] += 1
            xs, ys = zip(*island0)   # get xMax, yMax from island0
            xMax, yMax = max(xs) , max(ys)
            island1 = tuple(sorted((-x + xMax, y ) for x, y in island0))
            island2 = tuple(sorted((x, -y + yMax ) for x, y in island0))
            island3 = tuple(sorted((-x + xMax, -y + yMax) for x, y in island0))
            
            island4 = tuple(sorted((y, x) for x, y in island0))
            island5 = tuple(sorted((-y + yMax, x) for x, y in island0))
            island6 = tuple(sorted((y, -x + xMax) for x, y in island0))
            island7 = tuple(sorted((-y + yMax, -x + xMax) for x, y in island0))
            
            shapes |= set([island0, island1, island2, island3, island4, island5, island6, island7])
        
        for i in range(lrc[0]):
            for j in range(lrc[1]):
                shape = []
                dfs(i,j)
                if shape:
                    addShape(shape, shapes)
        return ans[0]

 

Update on 09/06/2023:

class Solution:
    def numDistinctIslands2(self, grid: List[List[int]]) -> int:
        self.ans = 0
        m, n, shapeSet = len(grid), len(grid[0]), set()
        visited = set()
        for i in range(m):
            for j in range(n):
                if grid[i][j] == 1 and (i, j) not in visited:
                    shape = []
                    self.helper(grid, visited, shape,  i, j, i, j)
                    self.addShape(shape, shapeSet)
        return self.ans
    

    def helper(self, grid, visited, shape, i, j, i0, j0):
        m, n = len(grid), len(grid[0])
        if 0 <= i < m and 0 <= j < n and (i, j) not in visited and grid[i][j] == 1:
            visited.add((i, j))
            shape.append((i - i0, j - j0))
            for d1, d2 in [(1, 0), (-1, 0), (0, 1), (0, -1)]:
                nr, nc = i + d1, j + d2
                self.helper(grid, visited, shape, nr, nc, i0, j0)
    
    def addShape(self, shape, shapeSet):
        rs, cs = zip(*shape)
        low_r, low_c = min(rs), min(cs)
        shape1 = tuple(sorted([(r - low_r, c - low_c) for r, c in shape]))
        if shape1 in shapeSet: return
        self.ans += 1
        local_rs, local_cs = zip(* list(shape1))
        high_r, high_c = max(local_rs), max(local_cs)
        shape2 = tuple(sorted([(-r + high_r, c) for r, c in shape1]))
        shape3 = tuple(sorted([(r, -c + high_c) for r, c in shape1]))
        shape4 = tuple(sorted([(-r + high_r, -c + high_c) for r, c in shape1]))
        shape5 = tuple(sorted([(c, r) for r, c in shape1]))
        shape6 = tuple(sorted([(-c + high_c, r) for r, c in shape1]))
        shape7 = tuple(sorted([(-c + high_c, -r + high_r) for r, c in shape1]))
        shape8 = tuple(sorted([(c, -r + high_r) for r, c in shape1]))
        shapeSet |= set([shape1, shape2, shape3, shape4, shape5, shape6, shape7, shape8])
        

 

 

4. test cases

the test cases in the beginning.